module Social
  class InstallGenerator < Rails::Generators::Base
    desc 'Creates a SocialEngagement model and db table'

    def create_social_engagement
      generate "model", "SocialEngagement facebook:integer twitter:integer url:string:uniq created_at:datetime updated_at:datetime --no-test-framework"
    end

    def migrate
      rake "db:migrate"
      rake "db:migrate RAILS_ENV=test"
    end

    def require_url_in_initializer
      initializer "social_engagement.rb", "require 'social/url'"
    end
  end
end
