module Social
  class Facebook
    ENDPOINT = 'http://graph.facebook.com/?id=URL'
    COUNT_KEY = 'shares'

    def self.total_count(url)
      begin
        response = Net::HTTP.get(URI(ENDPOINT.gsub('URL', url)))
        json = JSON.parse(response)
        if json.has_key?(COUNT_KEY)
          json[COUNT_KEY]
        else
          log_and_return_zero(url, response)
        end
      rescue StandardError => e
        log_and_return_zero(url, nil, e)
      end
    end

    private

    def self.log_and_return_zero(url, response = nil, exception = nil)
      log_message = "Could not get facebook engagement for url: #{url}\n"
      log_message << "Response: #{response}\n" if response.present?
      log_message << "Exception: #{exception.message}\n" if exception.present?
      Rails.logger.warn(log_message)
      0
    end
  end
end
