module Social
  module Model
    def self.included(base)
      base.validates :url, presence: true

      base.include InstanceMethods
      base.extend ClassMethods
    end

    module InstanceMethods
      def update_counts(social_engagement)
        unless social_engagement.facebook == facebook && social_engagement.twitter == twitter
          update(facebook: social_engagement.facebook, twitter: social_engagement.twitter)
        else
          touch
        end
      end
    end

    module ClassMethods
      def for_url(url)
        find_by_url!(url)
      end
    end
  end
end
